/*
 * Blob.cpp
 *
 *  Created on: Oct 6, 2008
 *      Author: Santi
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif


#include "debug.h"

#include "Blob.h"
#include "KObjectCreator.h"

#include "Knightmare.h"

Blob::Blob(int x,int y,int sfx_volume,GLTManager *GLTM) : KEnemy(x,y,sfx_volume)
{
	int i;

	m_points_on_kill = 10;
	
	m_class = blob_symbol;

    m_n_states = 2;
    m_state_animations = new Animation *[2];

    for(i=0;i<m_n_states;i++) m_state_animations[i]=0;

    m_state = 0;

	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("blob_crawling_001"),8);
	a->addFrame(GLTM->get("blob_crawling_002"),8);
	a->addFrame(GLTM->get("blob_crawling_003"),8);
	a->addFrame(GLTM->get("blob_crawling_004"),8);
	a->addFrame(GLTM->get("blob_crawling_003"),8);
	a->addFrame(GLTM->get("blob_crawling_002"),8);
	m_state_animations[0]=a;

	a = new Animation(false);
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_001"),1);
		a->addFrame(GLTM->get("enemy_dying_002"),1);
	}
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_002"),1);
		a->addFrame(GLTM->get("enemy_dying_003"),1);
	}
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_003"),1);
		a->addFrame(0,1);
	}
	m_state_animations[1]=a;
	
}


Blob::~Blob() {
}


bool Blob::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	if (!KEnemy::cycle(vcl,game,GLTM,SFXM)) return false;

	switch(m_state) {
	case 0: // advancing:
			m_y+=0.25f;
			if (m_y>game->get_map_position()+500) return false;
			if (m_health<=0) {
				SFXM->SFX_play("sfx/blob_hit", m_sfx_volume);
				m_state = 1;
				m_state_cycle = 0;
			}
			break;
	case 1: // dying:
			m_shadow_tile = 0;
			m_state_cycle++;
			if (m_state_cycle>36) return false;
			break;
	}
	
	return true;
}


bool Blob::is_a(Symbol *c)
{
    if (c->cmp(blob_symbol))
        return true;

    return KEnemy::is_a(c);
} /* Blob::is_a */


bool Blob::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* Blob::is_a */
